import Vue from 'vue'
import VueI18n from 'vue-i18n'
import { resourceStructures } from '../resourceStructures'

Vue.use(VueI18n)

const { resourceStructureAll, resourceInventory, resourceFeatureField, resourceStructureFinal } = resourceStructures()
const columnList = resourceFeatureField.locale
const structures = resourceStructureAll.locale

function handleStructures (structures, result, key) {
  if (['string', 'function'].includes(typeof structures)) return
  Object.values(structures).forEach(item => {
    const isItemHasEveryKey = columnList.every(key => Object.keys(item).includes(key))
    if (isItemHasEveryKey) {
      resourceInventory.locale[key].push(item.name)

      let message = {}

      message = Object.assign({}, item[key])
      result[item.name] = message

      handleStructures(item, result[item.name], key)
    } else {
      handleStructures(item, result, key)
    }
  })
}
columnList.forEach(key => {
  if (key !== 'name') {
    resourceInventory.locale[key] = []
    handleStructures(structures, resourceStructureFinal.locale[key] = {}, key)
  }
})

const i18n = new VueI18n({
  locale: 'zh',
  messages: resourceStructureFinal.locale
})
export default i18n
