import Mock from 'mockjs'
import { resourceStructures } from '../resourceStructures'

const { resourceStructureAll, resourceInventory, resourceFeatureField } = resourceStructures()
const columnList = resourceFeatureField.mock
const structures = resourceStructureAll.mock
function applyMock (module) {
  if (module) {
    Object.values(module).forEach((api, index) => {
      if (api.regExp) {
        Mock.mock(new RegExp(api.baseURL + api.regExp), api.method, options => api.response)
      }
    })
  }
}
function handleStructures (structures) {
  if (['string', 'function'].includes(typeof structures)) return

  Object.values(structures).forEach(item => {
    const isItemHasEveryKey = columnList.every(key => Object.keys(item).includes(key))
    if (isItemHasEveryKey) {
      resourceInventory.mock.push(item.name)
      applyMock(item)
      handleStructures(item)
    } else {
      handleStructures(item)
    }
  })
}

process.env.NODE_ENV === 'development' && handleStructures(structures)
