import lbCore from 'lb-core'
const resource = require.context('../../../../src/newtab/pages', true, /\/.*\/(api|locale|mock|route|store|page)$/)
lbCore.setResources(resource)
const structures = lbCore.getResourceStructures()
structures.resourceStructureFinal = {
  api: {},
  locale: {},
  route: [],
  store: {}
}
structures.resourceInventory = {
  api: [],
  locale: {},
  mock: [],
  page: [],
  route: [],
  store: []
}
structures.resourceFeatureField = {
  api: ['name', 'description', 'baseURL', 'url', 'method', 'data', 'params'],
  locale: ['name', 'zh', 'en'],
  mock: ['name', 'description', 'baseURL', 'method', 'regExp', 'response'],
  page: ['name'],
  route: ['path', 'component', 'name', 'meta', 'redirect'],
  store: ['state', 'getters', 'name', 'mutations', 'actions', 'namespaced']
}
console.log(structures)

export function resourceStructures () {
  return structures
}
