import Vue from 'vue'
import vuex from 'vuex'
import { resourceStructures } from '../resourceStructures'
const { resourceStructureAll, resourceInventory, resourceFeatureField, resourceStructureFinal } = resourceStructures()
const columnList = resourceFeatureField.store
const structures = resourceStructureAll.store

Vue.use(vuex)
function handleStructures (structures, result) {
  if (['string', 'function'].includes(typeof structures)) return

  Object.values(structures).forEach(item => {
    const isItemHasEveryKey = columnList.every(key => Object.keys(item).includes(key))
    if (isItemHasEveryKey) {
      resourceInventory.store.push(item.name)
      const module = {}
      columnList.forEach(key => { module[key] = item[key] })
      result[module.name] = module
      handleStructures(item, module.module = {})
    } else {
      handleStructures(item, result)
    }
  })
}
handleStructures(structures, resourceStructureFinal.store)
const store = new vuex.Store({
  strict: process.env.NODE_ENV !== 'production',
  modules: resourceStructureFinal.store
})
export default store
